%%
% Asteroid Finder Create Star Mask
%

fprintf('\n##################################\n');
fprintf('Create a binary star masks \n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  

%listFile='P21lkhv_list_AL.txt';
%listFile='P21ltbf_list_ALS.txt';
listFile='475665_list_ALS.txt';

[nameF,NF]=readList(listFile);
DATEOBS=cell(NF,1);
EXPTIME=cell(NF,1);
JD=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);
for nimg=1:NF
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    JD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(1);
     minCoor2(nimg,2)=theVal(3);
     maxCoor2(nimg,1)=theVal(2);
     maxCoor2(nimg,2)=theVal(4);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc
%%
fprintf('\n#####################\n');
fprintf('Step 2: Mask Generations \n');
tic

skRegFile='S475665_R4AL.reg';
theReg=readRegionDs9(skRegFile);
theFact=sqrt(2);
radiusOfD=2; % Radius of dilation 
minStars=150;  %5000
maxStars=1000;  %6000
debug=1;
%typeFactor= 'Std'; % Use Standar deviation
typeFactor= 'Background'; % Use Backgroung

[theMask, ...
    objCentroid, ...
    objArea,...
    objBox,...
    numObj,...
    finalFactor,...
    theVal] =patchStar_onlyMask(...
        Dcube,...
        theReg, ...
        theFact, ...
        radiusOfD, ...
        minStars,...
        maxStars,...
        typeFactor, ...
        debug);

toc

%%
fprintf('\n#####################\n');
fprintf('Step 3: Write The mask \n');
tic

maskName='S475665_Mask_ALS.fits';
maskNameTable='S475665_MaskTable_ALS.fits';
uArea1=zeros(2,2);
dim=size(theMask);



wfits_ALMask(...
        theMask,...
       maskName, ...
       maskName , ...
        minCoor(1,:),...
        maxCoor(2,:),...
        minCoor2(1,:),...
        maxCoor2(1,:),...
        radiusOfD,...
        minStars,...
        maxStars,...
        typeFactor, ...
        theFact, ...
        finalFactor,...
        theVal,...
        numObj,...
        DATEOBS{1},...
        JD{1},...
        '  ',...
       EXPTIME{1},...
        debug)

theTable=[objCentroid,double(objArea),double(objBox)];
fitswrite(theTable,char(maskNameTable));
import matlab.io.*
fptr= fits.openFile(char(maskNameTable),'readwrite');
fits.writeComment(fptr,'Aligned data cube allgoritms, TAOSII team');
fits.writeComment(fptr,'Authors: BHV/JSS/ESM');
dt=datetime('now');
sdt= sprintf('Date of Run: %s',dt);
fits.writeComment(fptr,sdt);
fits.writeComment(fptr,'Description table of found objects, sorted by area');
fits.writeComment(fptr,'Centroid [xc,yc]');
fits.writeComment(fptr,'Area [A]');
fits.writeComment(fptr,'ObjectBox: upper left corner [x1,y1], width, height');
fits.writeComment(fptr,'[xc, yc, A, x1, y1, width, height]');
fits.closeFile(fptr);

toc
