% %Master dir FZ/FZ_C0_06_15/
%
% Geneations of a "patch"around the stars, in the data cube.
%This process does not  substract the median of the data cube over itself

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  
%listFile='FZ_list_Aligned_BrAL2US.txt'; % only the usuable area 
%listFile='FZ_list_Aligned_BrAL2.txt'; % Compleate area
listFile='FZ_list_Aligned_BrAL_C0.txt';
[nameF,NF]=readList(listFile);

CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);

for nimg=1:NF
    CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(3);
     minCoor(nimg,2)=theVal(1);
     maxCoor(nimg,1)=theVal(4);
     maxCoor(nimg,2)=theVal(2);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc
%%
% Compute the Median
%
fprintf('\n#####################\n');
fprintf('Step 2: Compute the aligned median and the differences of median\n');
tic
fileMedian='FZ_Median_BrAL2.fits';
fileMedian='FZ_Median_BrAL_C0.fits';
fileCubeMedian='FZ_DiffOfMedian_BrAL_C0.fits';
[DM,Median_newCube]=diffOfMedian(Dcube); 
uArea1=zeros(2,2);
dim=size(Median_newCube);
uArea1(1,1)=1;
uArea1(1,2)=1;
uArea1(2,1)=dim(2);
uArea1(2,2)=dim(1);

uArea2=zeros(2,2);
uArea2(1,1)=max(minCoor(:,1));
uArea2(1,2)=max(minCoor(:,2));
uArea2(2,1)=min(maxCoor(:,1));
uArea2(2,2)=min(maxCoor(:,2));
debug=0;

wfits_AL05(...
        Median_newCube,...
       fileMedian, ...
       fileMedian, ...
        uArea1(1,:),...
        uArea1(2,:),...
        uArea2(1,:),...
        uArea2(2,:),...
        DATEOBS{1},...
        MJD{1},...
        CCD{1},...
       EXPTIME{1},...
        debug); 
 
 wfits_AL05(...
        DM,...
       fileCubeMedian, ...
       fileCubeMedian, ...
        uArea1(1,:),...
        uArea1(2,:),...
        uArea2(1,:),...
        uArea2(2,:),...
        DATEOBS{1},...
        MJD{1},...
        CCD{1},...
       EXPTIME{1},...
        debug); 
clear DM Median_newCube
toc
%%
fprintf('\n#####################\n');
fprintf('Step 3: Remove sky background trend & write data\n');
tic
% Use ds9 to slectect the regions and save it using IRAF pro format
skRegFile='FZ_Median_BrAL2.reg';
theReg=readRegionDs9(skRegFile);
%Otherwise write manualy the Region Description
% theReg: [Xc,Yc,Widht,Hight]

[skCube,skMedian,skStd,skMean]=skyAdjust2(single(Dcube),theReg);
skCube=int16(skCube);
clear Dcube;
%Write the data
newNameFile= strrep(nameF{1},'.fits','S_C0.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'DDotiAL01/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'DDotiAL01/','./');
%Reference image name
debug=0;
%Write Data Cube
parfor nimg=1:NF
    wfits_AL05(...
        skCube(:,:,nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
         minCoor(nimg,:),...
         maxCoor(nimg,:),...
        uArea2(1,:),...
        uArea2(2,:),...
        DATEOBS{nimg},...
        MJD{nimg},...
        CCD{nimg},...
         EXPTIME{nimg},...
        debug);     
end
toc

%%

