%DDOTI/OAN 28-cm f/2.2
% Second Alling process
% a-2002-silva-0
%Field 16:50:30.0 -02:39:30
% Experiment some Velocities of Patch Cubes

fprintf('\n##################################\n');
fprintf('Step 1: Read Data Cube and his header info\n');
tic  
%listFile='FZ_list_Aligned_BrAL2US.txt'; % only the usuable area 
%listFile='FZ_list_Aligned_BrAL2SMP.txt'; % Compleate area
listFile='FZ_list_Aligned_BrAL2SMP.2.txt'; % Compleate area
[nameF,NF]=readList(listFile);

CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor1=zeros(NF,2);
maxCoor1=zeros(NF,2);
minCoor2=zeros(NF,2);
maxCoor2=zeros(NF,2);

for nimg=1:NF
    CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor1(nimg,1)=theVal(1);
     minCoor1(nimg,2)=theVal(3);
     maxCoor1(nimg,1)=theVal(2);
     maxCoor1(nimg,2)=theVal(4);
     theVal=readHDR(nameF{1}(nimg,:),'AAREA2','[%d:%d,%d:%d]');
     minCoor2(nimg,1)=theVal(1);
     minCoor2(nimg,2)=theVal(3);
     maxCoor2(nimg,1)=theVal(2);
     maxCoor2(nimg,2)=theVal(4);
end
parfor nimg=1:NF
     Dcube(:,:,nimg)=int16( fitsread( char(nameF{1}(nimg,:)) ) );
end
toc

return
%%
%
fprintf('\n##################################\n');
fprintf('Step 2:Try some pixel velocities \n');
tic  

%testVel=[-13.3,1.2;...
%    -6.6, 2.4; ...
%    -3.2, 4.8];

velX=[-0.28, -0.24, 0.01]; % [min.nax.delta]
velY=[+ 0.024,  +0.028, 0.001];

% Vx vecto
nx=abs(floor( (velX(2)-velX(1)) / velX(3) ))+1;
a=rem( velX(2)-velX(1) ,  velX(3));
if a ~= 0
    nx=nx+1;
end
Vx=linspace(velX(1),velX(1)+(nx-1)*velX(3),nx);

% Vy vector
ny=abs(floor( (velY(2)-velY(1)) /velY(3) )) +1;
a=rem( velY(2)-velY(1) ,  velY(3));
if a ~= 0
    ny=ny+1; 
end
Vy=linspace(velY(1),velY(1)+(ny-1)*velY(3),ny);

expName='FZ_EX01_BrAL2SMP';
debug=0;
onlyNewName=strrep(nameF{1}(1,:),'DDotiAL01/','');
for i=1:length(Vx)
    for j=1:length(Vy)
      testVel=[Vx(i),Vy(j)];
      name=sprintf('%s_Vx%+5.4f_Vy%+5.4f.2.fits',expName,testVel(1),testVel(2));
      fprintf('[%d,%d]: %s\n',i,j,name);
      [theSum,minC3,maxC3]=sumShift_Gaps( Dcube,testVel ,MJD,0);
        wfits_Vel(...
        theSum,...
        name,...
        name, ...
        onlyNewName, ...
         minCoor1(1,:),...
         maxCoor1(1,:),...
        minCoor2(1,:),...
        maxCoor2(1,:),...
        minC3, ...
        maxC3, ...
        DATEOBS{1},...
        MJD{1},...
        CCD{1},...
         EXPTIME{1},...
        debug);     
    end
end

toc


