%%
%DDOTI/OAN 28-cm f/2.2
% a-2002-silva-0
%Field 16:50:30.0 -02:39:30
%2021-06-15T
%CCDSEC  = '[1:6144,55:6198]'                                                    
%DATASEC = '[1:6144,55:6198]'                                                    
% BIASSEC = '[1:6144,7:22]'
% Master dir FZ/FZ_C0_06_15/
%
% 
%clear all



% read the List, extraxt the bias for data science
% and keep only the data science
%listFile='FZ_list_C5_short_010I.txt';
%listFile='FZ_list_C0_short_010I.txt';
%listFile='FZ_list_short_005I.txt';
%listFile='FZ_list_short_010I.txt';
listFile='FZ_list_2Analize.txt';
%listFile='FZ_list.txt'; %Full list
[nameF,NF]=readList(listFile);
debug=1;
%ccdName=cell(NF,1);
[D2Cube,B2Cube,newNF,ccdName]=Read_DataCube_Dotii_fits(nameF,NF,debug);
Dcube=rmBias(D2Cube,B2Cube,'local');
clear D2Cube B2Cube

parfor nimage=1:newNF
    Dcube(:,:,nimage)=DDoti_flip( Dcube(:,:,nimage), ccdName{nimage},nimage,debug);
end

%% Collect detected Point
radio=5;
minArea=round(radio^2*pi); %minmum area of the disk
maxArea=1000; %maximarea of the disk
global thePoint
%Threshold for detect star
umbral=0.65;

thePoint=cell(newNF,5);
theArea=cell(newNF,1);
theCenter=cell(newNF,1);
theBox=cell(newNF,1);
theNP=cell(newNF,1);
theTR=cell(newNF,1);
debug=1;

desvUmbral=0.22;
bestPoints=15;
minPoints=10;
maxPoints=45;


parfor nimg=1:newNF
   
    [theArea{nimg},theCenter{nimg},theBox{nimg},theNP{nimg},theTR{nimg}]=...
        findPointsDDoti(single(Dcube(:,:,nimg)),...
        umbral, desvUmbral, radio,minArea,maxArea, ...
        bestPoints,minPoints, maxPoints, nameF{1}(nimg),debug);
    
  
end

thePoint(:,1)=theArea;
thePoint(:,2)=theCenter;
thePoint(:,3)=theBox;
thePoint(:,4)=theNP;

for nimg=1:newNF
    thePoint{nimg,5}(1:thePoint{nimg,4},1)=-1;
end



%% 
% Search common points
% minum search Radius 
dim=size(Dcube);
sizeX=dim(2); % The columns is axis X
sizeY=dim(1); % The row is axis Y

searchRadius=sizeX;
%for nimg=1:newNF
 %   old=minHalfDistance(thePoint{nimg,2},[sizeX,sizeY]);
 %   if old < searchRadius
 %      searchRadius=old;
 % end
% end
facDistace=0.9;
imgDistMin=0;

for nimg=1:newNF
   old=(min(pdist(thePoint{nimg,2})))*facDistace;
   if old < searchRadius
       searchRadius=old;
       imgDistMin=nimg;
   end
end


% search all points in the first image
refImg=1; % first frame
matchP=cell(thePoint{refImg,4},1);
 for p=1:thePoint{refImg,4}
          matchP{p}=matchPoint(p,refImg,newNF,searchRadius);
 end

  % Common point found in all image
  ncomm=0;
  commP=zeros(thePoint{refImg,4},1);
  c=newNF-2;
   for p=1:thePoint{refImg,4}
       if (thePoint{refImg,5}(p) == c)
           ncomm=ncomm+1;
           commP(ncomm)=p;
       end
   end
%  vecY(1)=thePoint{1,2}(1,2);
%  for i=1:201;  img=matchP{1,1}(i,1); point=matchP{1,1}(i,2); vecY(i+1)=thePoint{img,2}(point,2); end
%  plot (vecY)

fprintf('I found: %d common  points \n', ncomm);
for p=1:ncomm
    fprintf('%3d: P[%d]: ( %4.2f, %4.2f ) \n', ...
        p, ...
        commP(p),...
        thePoint{refImg,2}(commP(p),1), ...
         thePoint{refImg,2}(commP(p),2))
end
fprintf('\n');

debug=1;
if debug
       objBox=zeros(ncomm,4);
       for p=1:ncomm
           objBox(p,:)=thePoint{refImg,3}(commP(p),:);
           objCentroid(p,:)=thePoint{refImg,2}(commP(p),:);
       end
       delta=15;
        bboxOut_2(:,1)=objBox(:,1)-delta;
        bboxOut_2(:,2)=objBox(:,2)-delta;
        bboxOut_2(:,3)=objBox(:,3)+2*delta;
        bboxOut_2(:,4)=objBox(:,4)+2*delta;
        M=log(single(Dcube(:,:,refImg)));
        fact=1/(max(M(:))-min(M(:)));
        themin=min(M(:));
        MNor=(M - themin).*fact;
        imgShape= insertShape(MNor,'rectangle',bboxOut_2,'Linewidth',14,'Color',[255 0 0]);
        imshow(imgShape);
       clear M MNor 
       
        delta2=delta+10;
       textPos=round(objCentroid+delta2);
       imgSize=size(Dcube(:,:,refImg));
       xmax=imgSize(2);
       ymax=imgSize(1);
       for i=1:ncomm
            if(textPos(i,1) > (xmax -150))
                 textPos(i,1)=round(objCentroid(i,1)-(2*delta2));
            end
            if(textPos(i,2) > (ymax -50))
              textPos(i,2)=round(objCentroid(i,2)-(2*delta2));
            end
       end
      
       text_objstr = cell(ncomm,1);
       for i=1:ncomm
          text_objstr{i}=['P[' num2str(i,'%d') ']' ];
       end

       imgShapeText=insertText(imgShape,  textPos, text_objstr, ...
            'TextColor','yellow','FontSize',100,'BoxColor' ,[1 1 1],...
            'BoxOpacity',0);
       imshow(imgShapeText);
       t=sprintf('%s ',char(nameF{1}(refImg)));
       t2=sprintf('Points found: %d',ncomm);
       title([t,t2],'Interpreter', 'none');

end

%% Compute the Rotation and Translation transform
% RefB=RA+t

% Minimum 2 points is better 3 or more manula
%commP2=[1;2;7;8]; %for ths aproach P1,P2,P7,P8
%ncomm2=4;
%All poits
commP2=commP(1:ncomm);
ncomm2=ncomm;

%trasformR(i,1)= R (rotation)
%trasformR(i,2)= t (translation)
transformR=cell(newNF,2);

%RefPoint corresponds to points in 1st image
for k=1:ncomm2
    refB(k,:)=thePoint{1,2}(commP2(k),:);
end
transformR{1,1}=[1,0;0,1];
transformR{1,2}=[0;0];

for  nimg=2:newNF
    for k=1:ncomm2
         rowM=find(matchP{commP2(k)}(:,1)==nimg);
         pImg2=matchP{commP2(k)}(rowM,2);
          A(k,:)=thePoint{nimg,2}(pImg2,:);
    end
    [transformR{nimg,1}, transformR{nimg,2}]=...
        rigidTransform2D(A, refB);
end

%
%%  Align Images

AlignCube=zeros(size(Dcube),'like',Dcube);
AlignCube(:,:,1)=Dcube(:,:,1);
minCoor=zeros(newNF,2);
maxCoor=zeros(newNF,2);
minCoor(1,1)=1;
minCoor(1,2)=1;
maxCoor(1,1)=sizeX;
maxCoor(1,2)=sizeY;
parfor nimg=2:newNF
    [AlignCube(:,:,nimg), minCoor(nimg,:),maxCoor(nimg,:)] = ...
        doAlign( Dcube(:,:,nimg) , [sizeX sizeY] ,transformR{nimg,1},transformR{nimg,2});
end

debug=1;

if debug
    A=single(Dcube(:,:,refImg));
    A=log(A);
    fact=1/(max(A(:))-min(A(:)));  themin=min(A(:)); A=(A-themin).*fact;
    objBox=zeros(ncomm,4);  
     for p=1:ncomm
           objBox(p,:)=thePoint{refImg,3}(commP(p),:);
     end
    delta=17;
   
    bboxOut_2(:,1)=objBox(:,1)-delta;
    bboxOut_2(:,2)=objBox(:,2)-delta;
    bboxOut_2(:,3)=objBox(:,3)+2*delta;
    bboxOut_2(:,4)=objBox(:,4)+2*delta;
        
    ishapeA= insertShape(A,'rectangle',bboxOut_2,'Linewidth',14,'Color',[255 0 0]);
    clear A
    %imshow(imgShape);
    % Cual quieres ver
    cual=newNF;
    B=single(Dcube(:,:,cual));
    B=log(B);
    fact=1/(max(B(:))-min(B(:)));  themin=min(B(:)); 
    B=(B-themin).*fact;
    figure(1)
    imshowpair(ishapeA,B,'montage');
    s=sprintf('Left Reference Image [ %d ]    Rigth Image  to be alligned [ %d]', refImg,cual);
    title(s);
    
    pause(2);
    
    figure (2)
    imshowpair(ishapeA,B,'blend','Scaling','joint');
    title('Joint A-ref  and B');
    pause(1);
    
    C=single(AlignCube(:,:,cual));
    C=log(C);
    fact=1/(max(C(:))-min(C(:)));  themin=min(C(:)); C=(C-themin).*fact;
    figure (3)
    imshowpair(ishapeA,C,'blend','Scaling','joint');
    title('Joint A and B-alligned ');
    pause(1);
    
    [DofM,M]=diffOfMedian(Dcube);
    M1=log(single(M));
    fact=1/(max(M1(:))-min(M1(:))); themin=min(M1(:)); M1=(M1-themin).*fact;
    
     [DofM2,M2]=diffOfMedian(AlignCube);
    M3=log(single(M2));
    fact=1/(max(M3(:))-min(M3(:))); themin=min(M3(:)); M3=(M3-themin).*fact;
     s=sprintf('Left Median of the  Data Cube  Rigth Median of the Aligned Data Cube');
     
     figure(4);
      imshowpair(M1,M3,'montage');
      title(s);
      pause(1);
    
    
end

%%
% Write the  alligned Data.

% Add "*BrAL.fits"  to the original name
newNameFile= strrep(nameF{1},'.fits','BrAL.fits');
% remove the directory
onlyNewName=strrep(newNameFile,'FZ/FZ_C0_06_15/','');
% change de original directory to working directorory "./"
newNameFile= strrep(newNameFile,'FZ/FZ_C0_06_15/','./');
%Reference image name
refImageName=strrep(nameF{1}(refImg),'FZ/FZ_C0_06_15/','');

%Write Data Cube
debug=0;
tic
parfor nimg=1:newNF
    wfits_AL(...
        AlignCube(:,:,nimg),...
        nameF{1}(nimg),...
        newNameFile{nimg},...
        onlyNewName{nimg}, ...
        refImageName,...
        minCoor(nimg,:),...
        maxCoor(nimg,:),...
        transformR(nimg,1),...
        transformR(nimg,2),...
        newNF,...
        theTR{nimg},...
        {'LOG'},...
        radio,...
        minArea,...
        maxArea,...
        ncomm,...
        debug);     
end
toc

clear Dcube
%%
%  Write the Median

fileMedian='FZ_C5_MedianCube.fits';
fileCubeMedian='FZ_C5_CubeRemovedMedian.fits';
[DM,Median_newCube]=diffOfMedian(AlignCube);
fitswrite(Median_newCube,fileMedian);
fitswrite(DM,fileCubeMedian);
clear DM Median_newCube

