%
%
% HDF5 Vector of Pixel Shift elocity according a velocity range
%


% Name of files 
listFile='FZ_list_Aligned_BrAL2.txt'; % only the usuable area 
[nameF,NF]=readList(listFile);

%range of velocity [min,max,delta]
delta=0.1;
rangeVelX=[-10,10,delta]; 
rangeVelY=[-10,10,delta]; 
% uniform Increment


% Read the Header of fits files
CCD=cell(NF,1);
DATEOBS=cell(NF,1);
MJD=cell(NF,1);
EXPTIME=cell(NF,1);
minCoor=zeros(NF,2);
maxCoor=zeros(NF,2);

for nimg=1:NF
    CCD{nimg}=readHDR(nameF{1}(nimg,:),'CCD_NAME','%s');
    DATEOBS{nimg}=readHDR(nameF{1}(nimg,:),'DATE-OBS','%s');
    MJD{nimg}=readHDR(nameF{1}(nimg,:),'MJD','%d');
     EXPTIME{nimg}=readHDR(nameF{1}(nimg,:),'EXPTIME','%d');
     theVal=readHDR(nameF{1}(nimg,:),'AAREA','[%d:%d,%d:%d]');
     minCoor(nimg,1)=theVal(1);
     minCoor(nimg,2)=theVal(3);
     maxCoor(nimg,1)=theVal(2);
     maxCoor(nimg,2)=theVal(4);
end
sizeCube(1)=readHDR(nameF{1}(nimg,:),'NAXIS1','%d');
sizeCube(2)=readHDR(nameF{1}(nimg,:),'NAXIS2','%d');
sizeCube(3)=NF;

% compute the range of velocity
nx=abs(floor( (rangeVelX(2)-rangeVelX(1)) / rangeVelX(3) ))+1;
a=rem( rangeVelX(2)-rangeVelX(1) ,  rangeVelX(3));
if a ~= 0
    nx=nx+1;
end
Vx=linspace(rangeVelX(1),rangeVelX(1)+(nx-1)*rangeVelX(3),nx);

ny=abs(floor( (rangeVelY(2)-rangeVelY(1)) /rangeVelY(3) )) +1;
a=rem( rangeVelY(2)-rangeVelY(1) ,  rangeVelY(3));
if a ~= 0
    ny=ny+1;
end
Vy=linspace(rangeVelY(1),rangeVelY(1)+(ny-1)*rangeVelY(3),ny);


nmovX=length(Vx);
nmovY=length(Vy);

theV=zeros(2,nmovX*nmovY);
theShift=zeros(NF,2,nmovX*nmovY);

c=0;
for vx=1:nmovX
    for vy=1:nmovY
        c=c+1;
        theV(1,c)=Vx(vx);
        theV(2,c)=Vy(vy);
         [theShift(:,:,c) ,  ~, ~ ] = pixvecVelocityGaps( MJD,theV(:,c),sizeCube);
    end
end

% Write Data
% Name of HDF5
fileName='DdotiVelocity.h5';
experimentName='/EX0001';

dim=size(theV);
grp=strcat(experimentName,'/Velocity');
h5create(fileName,grp,[dim]);
h5write(fileName,grp,theV);

dim=size(theShift);
grp=strcat(experimentName,'/Shift');
h5create(fileName,grp,[dim]);
h5write(fileName,grp,theShift);

dim=size(rangeVelX);
grp=strcat(experimentName,'/RangeVelX');
h5create(fileName,grp,[dim]);
h5write(fileName,grp, rangeVelX);

dim=size(rangeVelY);
grp=strcat(experimentName,'/RangeVelY');
h5create(fileName,grp,[dim]);
h5write(fileName,grp, rangeVelY);




