function [ Dout ] = asteroid_level( Data, ntimes )
% Detect the upper values above Ntimes the statandar deviation oves the means in a image,
% and subtitut it by the median on a box of 3x3 arround the pixel. The pixel is not takes into the account.
%The asteroide must have pixel values < ntimes the std.
% Input:
%   Data:  NxM image
%   ntimes: factor of the std
%Output:
%   Dout: NxM image
%
%BHV Dec 2021
%   

Dout=ones(size(Data),'like',Data);

theMean=mean(single(Data(:)));
theStd=std(single(Data(:)));
upperL=ntimes*theStd+theMean;
Dout=Data;
[P(:,1),P(:,2)]=find(Data> upperL);

s=size(Dout);

% Replace de pixel with the median of the  3x3 neighborhood 
v=zeros(8,1);
for ipoint=1:length(P)
    if( P(ipoint,1)  > 1 &&   P(ipoint,1) < s(1)  && ...
        P(ipoint,2)  > 1 &&   P(ipoint,2) < s(2))
        n=0;
        for j=-1:1
            for k=-1:1
                if (j ~= 0  ||  k  ~= 0 )
                    n=n+1;
                    v(n)=Dout(P(ipoint,1)+j ,P(ipoint,2)+k);
                end
            end
        end
        theVal=round(median(v));
        if (theVal>upperL)
            theVal=min(v);
        end
        Dout(P(ipoint,1) ,P(ipoint,2))=theVal;
    else
         Dout(P(ipoint,1) ,P(ipoint,2))=round(theMean);
    end
    
end


end

