function [ outHDR ] = chvalHDR( HDR,theKey,theVal, theComment,theType)
%Modify, add or delete  some fits header Keyword 
%   USAGE: [ outHDR ] = chvalHDR( HDR,theKey,theVal, theComment,theType)
%INPUT
%  HDR: fits header
%  theKey: Name of the variable
%  theVal: Value
%  theComment: coment of the value
%  theType: type of operation
%       'End2Comment' comment teh original END Keyword position
%       'Add' insert a new keyword
%       'Erase' delete a keyword including his value and comments
%       'Modify' update some keyword value. 
%OUTPUT
%   outHDR: the new header
%
%BH Aug 2021

%Red the what tyoe of modificacation do you like
outHDR=HDR;
opt={'End2Comment','Add','Erase','Modify'};
TF = strcmpi(opt,theType);
flag=0;
for i=1:length(opt)
    if TF(i)
        flag=1;
        break;
    end
end

if ~flag
     fprintf('Error: Type of modifcation mismatch (%s)\n' ,theType);
     fprintf('Error: Use: End2Comment Add Erase or Modify\n');
     fprintf('Error: Return the the same HDR n');
     return;
end

%Special case 'End2Comment'
% Convert the END keyword to comment, in order to
% see the original END position in HDR
if TF(1)
    [tf, idx] = ismember('END', HDR(:,1));
    if ~tf
       fprintf('Warning: the keyword [%s] does not exists!\n',char(theKey));
       fprintf('Warning: do nothing.....');
       return;
    end
    outHDR(idx,1)={'COMMENT'};
    outHDR(idx,2)={[]};
    outHDR(idx,3)={'Original position of END keyword'};
    return
elseif TF(2)  % Add a lines
    idx=length(outHDR)+1;
    TF = strcmpi('COMMENT',theKey);
    if TF
       outHDR(idx,1)={'COMMENT'};
       outHDR(idx,2)={[]};
       outHDR(idx,3)={theComment};
       return
    end
     outHDR(idx,1)={theKey};
     outHDR(idx,2)={theVal};
     outHDR(idx,3)={theComment};
elseif  TF(3)  % erase
    [tf, idx] = ismember(theKey, HDR(:,1));
    if ~tf
       fprintf('Warning: the keyword [%s] does not exists!\n',char(theKey));
       fprintf('Warning: do nothing.....');
       return;
    end
     outHDR(idx,:)=[];
else % modify
    [tf, idx] = ismember(theKey, HDR(:,1));
    if ~tf
       fprintf('Warning: the keyword [%s] does not exists!\n',char(theKey));
       fprintf('Warning: do nothing.....');
       return;
    end
    TF = strcmpi('COMMENT',theKey);
    if TF
       fprintf('Warning: the keyword [%s] has multiple instances!\n',char(theKey));
       fprintf('Warning: do nothing.....');
       return;
    end
    outHDR(idx,2)={theVal};
    outHDR(idx,3)={theComment}; 
end

end

