function [ output_args ] = masterAsteroidFineder( ...
    DataCube,...
    vpX,...
    vpY )
%The master asteroide finder algorithm on CPU
%   Detailed explanation goes here
%
%
%Input:
%DataCube:  the alligned and enhanced data cube
%vpX:               the velocity vector pixel  over X axis (VXini,VXend,VXdelta)
%vpY:               the velocity vector pixel   over Y axis (VYini,VYend,VYdelta)
%
%
%
%July 2021
%BH

% Compute the Vx and Vy vector
nx=abs(floor( (velX(2)-velX(1)) / velX(3) ))+1;
a=rem( velX(2)-velX(1) ,  velX(3));
if a ~= 0
    nx=nx+1;
end
Vx=linspace(velX(1),velX(1)+(nx-1)*velX(3),nx);

ny=abs(floor( (velY(2)-velY(1)) /velY(3) )) +1;
a=rem( velY(2)-velY(1) ,  velY(3));
if a ~= 0
    ny=ny+1;
end
Vy=linspace(velY(1),velY(1)+(ny-1)*velY(3),ny);

[A,B] = meshgrid(Vx,Vy);
C=cat(2,A,B);
theV=reshape(C,[],2);
theV=theV.';

[~,nmov]=size(theV);
[rtot,ctot,deep]=size(Data);

for ii=1:nmov
        [theSS(:,:,ii),minC(:,ii),maxC(:,ii)]=...
            sumShift(Data,theV(:,ii),sflag);
end


end

