function [ outHDR ] = newHDR( theFile,...
    imgsize,...       % the new image size
    newName, ... %  New file alligned file name
    minCoor,...   %  Usuable Area (row,col)
    maxCoor,...   % Usuable Area (row,coll)
    RM, ...             % Rotations Matrix
    TV, ...               % Translation Vector
    deep, ...           % number of deep data Cub
    threshold, ...  %Theshold use for binarize
    theScale, ...     %Image scale user for binarize
    theRadius, ...     % Radius of the circular prototype mask
    theMinArea, ... %Minumim Circular area
    theMaxArea, ... %Maximum Circular area
    theCPoint, ...   %Number of the common control points used
    debug)
% Write the parameters used for align DDOTI data cube, in a new header fits
% format
%   Detailed explanation goes here

theInfo=fitsinfo(char(theFile));
outHDR=theInfo.PrimaryData.Keywords;

%cancel END of Header
outHDR=chvalHDR(outHDR,'','','','End2Comment');

% Erase Chesum and datasum
outHDR=chvalHDR(outHDR,'CHECKSUM','','','Erase');
outHDR=chvalHDR(outHDR,'DATASUM','','','Erase');
%Identification of Process
outHDR=chvalHDR(outHDR,' COMMENT','',...
    'Aligned data cube allgoritms, matlab BHV/JSS/ESM','ADD');
outHDR=chvalHDR(outHDR,' COMMENT','',...
    'All new keywords begin with A','ADD');
dt=datetime('now');
outHDR=chvalHDR(outHDR,' COMMENT','',...
    sprintf('Date of Run: %s',dt),...
    'ADD');

% All the new keyword begin with "A" (Alligned parameters)

% Image size
outHDR=chvalHDR(outHDR,'NAXIS1',imgsize(2),'','Modify');
outHDR=chvalHDR(outHDR,'NAXIS2',imgsize(1),'','Modify');

% New file Name
outHDR=chvalHDR(outHDR,'ANAME',newName,'','ADD');

% Usable Area affter allign
% min/max Coor is in Image  Coord that mean
%that axisX is the seconde component (the columns)  and
% the axisY is firts component  (the row) 
%UAREA=[minX:maxX,minY:masY] format
str_uArea=sprintf('[%d:%d,%d:%d]', minCoor(2),maxCoor(2),...
    minCoor(1),maxCoor(1));
outHDR=chvalHDR(outHDR,'AAREA',str_uArea,'Usuable area','ADD');

% Rigid Transformation Rotation Matrix and Trasnlation Vector 
outHDR=chvalHDR(outHDR,'ACD1_1',RM{1}(1,1),'Rotation matrix','ADD');
outHDR=chvalHDR(outHDR,'ACD1_2',RM{1}(1,2),'Rotation matrix','ADD');
outHDR=chvalHDR(outHDR,'ACD2_1',RM{1}(2,1),'Rotation matrix','ADD');
outHDR=chvalHDR(outHDR,'ACD2_2',RM{1}(2,2),'Rotation matrix','ADD');
outHDR=chvalHDR(outHDR,'ATV1',TV{1}(1),'Translation vector X-axis ','ADD');
outHDR=chvalHDR(outHDR,'ATV2',TV{1}(2),'Translation vector Y-axis','ADD');

% Parametres of the deteted control points for alligned process
outHDR=chvalHDR(outHDR,'ADEEP',deep,'Data cube depth','ADD');
outHDR=chvalHDR(outHDR,'ATHRE',threshold,'Threshold used to binarize','ADD');
outHDR=chvalHDR(outHDR,'ASCL',theScale,'Image scale used LOG|LINEAR','ADD');
outHDR=chvalHDR(outHDR,'ARADIUS',theRadius,'Disk prototype mask radius','ADD');
outHDR=chvalHDR(outHDR,'AMINA',theMinArea,'Minumim circular area','ADD');
outHDR=chvalHDR(outHDR,'AMAXA',theMaxArea,'Maximum circular area','ADD');
outHDR=chvalHDR(outHDR,'APOINT',theCPoint,'Number of common controls point used','ADD');

%When I finished inset the END KEY
outHDR=chvalHDR(outHDR,'END','','','ADD');

end

