function B=noncircshift(A,offsets)
%Like circshift, but shifts are not circular. Missing data are filled with
%zeros.
%
%  B=noncircshift(A,offsets)
%  offset (row, col)
%              (y, x) 
%
siz=size(A);
N=length(siz);
if length(offsets)<N
   offsets(N)=0; 
end
B=zeros(siz,'like',A);
indices=cell(3,N);
for ii=1:N
      for ss=[1,3]
       idx=(1:siz(ii))+(ss-2)*offsets(ii);
        idx(idx<1)=[];
        idx(idx>siz(ii))=[];
       indices{ss,ii}=idx;
      end
  end
src_indices=indices(1,:);
dest_indices=indices(3,:);
B(dest_indices{:})=A(src_indices{:});

end

