function [ A ] = normalizeData( Data,type )
%Normalize (0...1) a matrix in linear or log type
%  Usage: A normalizeData( Data,'Linear'|'Log' )
%BH jun 2021

if  ~ismatrix(Data)
    fprintf("Error: The Data must be 2D matrix, your data has %d dimentions ..,\n aborting ...", ndims(Data));
    A=[];
    return;
end

opt={'Linear','Log'};

TF = strcmpi(opt,type);

if ~TF(1) &&   ~TF(2)
     fprintf("Error: Type of scale mismatch (%s). \n\tWrite Linear or Log ... \n\tAboorting ..\n", type);
     A=[];
     return;
end

A=Data;
if TF(2)
    minA=min(A(:));
    if minA <= 0
        A=A+(1-minA);
    end
    A=log(A);
end
minA=min(A(:));
 fact=1/(max(A(:))-minA);
 A=(A - minA).*fact;



end

