function [ theMask,  objCentroid, objArea,objBox, numObj,finalFactor,theVal ] = patchStar_onlyMask(...
    Cube,...
    theReg,...
    theFactor, ...
    radius, ...
    minStars,...
    maxStars,...
    theType,...
    debug )
%  Improved data cube using background regions above the median, in addition 
%  to calculating a star mask to remove them in analysis
%  Usage:   [ theMask,  objCentroid, objArea,objBox, nData] =
%  patchStar_onlyMask(Cube, theReg, theFactor, bgFlag, radius, minStars, maxStars,theType, debug )
%
%Input:
%Cube: Data Cube
%theReg: Regions to extract the median of the background sky
%bgFactor:  background|Standar_Dev factor for detecting any star
% radius: Radius of the dilation mask
%minStars: Minumun number of detected star
%maxStars: Maximum number of detected star
%theType:  [Background|Std] 
% debug: verbosity 
%
% jun 2021
%BH

opt={'Background','Std'}; 
TF = strcmpi(opt,theType);

if ~TF(1) &&   ~TF(2)
     fprintf("Warning: The factor  must be [Background|Std] . You typed %s \t I do nothing ..\n", theType); 
     return;
end
 
Median=single(onlyMedian(Cube));
%debug=0;
[theMask, objCentroid, objArea,objBox,...
    numObj,finalFactor,theVal]=maskMedian_Type(Median,theReg,theFactor,radius,minStars, maxStars, TF, debug);

end

