function [ argHDR ] = readHDR( theFile, theKey, theFormat )
%Read keyword value from the  image fits header
%   Usage:  [ argHDR ] = readHDR( theFile.theKey )
%
%
%
%
%
%BH July 2021

theInfo=fitsinfo(char(theFile));
keyW=theInfo.PrimaryData.Keywords;
[tf, idx] = ismember(theKey, keyW(:,1));
if ~tf
    fprintf('Warning: the keyword [%s] does not exists!\n',char(theKey));
    fprintf('\t output argumet set to void cell...');
     argHDR=cell(1);
     return;
end
theVal= keyW(idx,2);


if isnumeric(theVal{:})    % check if the value is a numeric
    argHDR=cell2mat(theVal);
    return;
end
    
if ischar(theVal{:})    % check if the value is a numeric
    argHDR=sscanf(char(theVal{:}),theFormat);
    return;
else
     fprintf('Warning: the keyword [%s] does not  a number or char string !\n',char(theKey));
    fprintf('\t output argumet set to void cell...');
     argHDR=cell(1);
     return;
end

end

