function [mC,sC ,pC] = skyAdjustOnlyStats( theCube, theReg )
%SkyAdjust funtions
% Input:
% Cube: data cube only for usuable area
% theCenter[x,y]:  Center of the sky only region
% theDim[w,h];  with,higth of the region
% Output:
% mC:   median of the region frames
% sC; Standar desv   of the region frames
% pC; media  of the region frames

[~,~,deep]=size(theCube);
[iiReg,~]=size(theReg);

for ii=1:iiReg
    cx=round(theReg(ii,1));
    cy=round(theReg(ii,2));
    w=round(theReg(ii,3)/2.);
    h=round(theReg(ii,4)/2.);
    nReg=theCube(cy-h:cy+h, cx-w:cx+w,:);
    n2Reg=reshape(nReg,[],deep);
    if (ii == 1)
        totReg=n2Reg;
    else
         totReg=[totReg; n2Reg];  
    end
    
end  

mC=median(totReg);
sC=std(totReg);
pC=mean(totReg);

end

