function [ theSum, minCoor,maxCoor ] = sumShift( theCube, pv, sflag )
%sumShift() sum and shift the data cube according  some velocity pixel 
%vecor(v_x,v_y)
%  Input
% theCube data cube (r,c,deep)
% pv: velocity pixel  vector [vx,vy]
% sflag:  Outuput Size
%        0: Same that the original image
%        1: Only usable area
%
%Output:
%theSum: Summed & Shifted Image
%minCoor: Origin coordinate (Xmin,Ymin) Column vector
%maxCoor: Then max coordinate (Xmax, Ymax) Column Vector
%
%Jun 2021
%BH

[rtot,ctot,deep]=size(theCube);
vPixel=zeros(deep,2);
theSumC=zeros(rtot,ctot,deep,'like',theCube);
minCoor=ones(2,1);
maxCoor=zeros(2,1);
maxCoor(1)=ctot;
maxCoor(2)=rtot;
ssx=1; 
ssy=1;
if(pv(1) < 0 )
    ssx=-1;
end
if(pv(2) < 0 )
    ssy=-1;
end
k_x=-pv(1)-0.4999*ssx;
k_y=-pv(2)-0.4999*ssy;
for i=1:deep
    k_x=k_x+pv(1);
    k_y=k_y+pv(2);
    vPixel(i,2)=round ( k_x);
    vPixel(i,1)=round ( k_y);
end

parfor i=1:deep
    theSumC(:,:,i)=noncircshift(theCube(:,:,i), vPixel(i,:));
end

A=single(sum(theSumC,3));
 
if ssx == 1
    minCoor(1)= max(vPixel(:,2))+1;
else
    maxCoor(1) = ctot+min(vPixel(:,2));
end

if ssy == 1
    minCoor(2)= max(vPixel(:,1))+1;
else
    maxCoor(2) = ctot+min(vPixel(:,1));
end

if sflag
    theSum=A(minCoor(2):maxCoor(2),  minCoor(1): maxCoor(1));
else
    theSum=A;
end

end

