function [ vPixel, minCoor,maxCoor] = velPixel( pv,rtot,ctot,deep )
%Compute the integer shifted pixel verctor, over the deep data cube, 
%that correspond a some pixel velocity pv.
%  Usage: [ vPixel, ssx, ssy] = velPixel( pv,deep )
%
%Input
%pv: velocity pixel  vector [vx,vy]
%deep: deep of data cube
%
%Outut:
%vPixel: Velocity table  Vy_i, Vx_i  i=1...deep
%ssx: sign of Vx
%ssy:  sign of Vy
%
%jun 2021
%BH 


ssx=1; 
ssy=1;
if(pv(1) < 0 )
    ssx=-1;
end
if(pv(2) < 0 )
    ssy=-1;
end
vPixel=zeros(deep,2);

k_x=-pv(1)-0.4999*ssx;
k_y=-pv(2)-0.4999*ssy;
for i=1:deep
    k_x=k_x+pv(1);
    k_y=k_y+pv(2);
    vPixel(i,2)=round ( k_x);
    vPixel(i,1)=round ( k_y);
end
minCoor=ones(2,1);
maxCoor=zeros(2,1);
maxCoor(1)=ctot;
maxCoor(2)=rtot;

if ssx == 1
    minCoor(1)= max(vPixel(:,2))+1;
else
    maxCoor(1) = ctot+min(vPixel(:,2));
end

if ssy == 1
    minCoor(2)= max(vPixel(:,1))+1;
else
    maxCoor(2) = ctot+min(vPixel(:,1));
end

end

