function [  ] = wfits_AL05(...
    Data, ... % the Imagee
    newName, ... %  New  alligned file name with path
    onlyName, ... % previous with out path
    minCoor1,...   %  Usuable Area (x,y)
    maxCoor1,...   % Usuable Area (x,y)
    minCoor2,...   %  Usuable Area (x,y)
    maxCoor2,...   % Usuable Area (x,y)			   
     val1, ...       %DATE-OBS
     val2, ...       %MJD
     val3, ...       %CCD_NAME
     val4, ...       %EXPTIME
    debug) 
%Write the Data in a fits file format. Also include the header value
%   Detailed explanation goes here A
%
%
%
%
% BH Aug 2021

import matlab.io.*

[filepath, ~, ~] = fileparts(newName);
if strcmp(filepath,'.') %Grrrrr matlab can not manage the format "./file"
    if exist(char(onlyName),'file') == 2
      fprintf('Warning: the file [%s] exist. I remove it..\n',char(newName));
      delete(newName);
    end
else
    if exist(char(newName),'file') == 2
        fprintf('Warning: the file [%s] exist. I remove it..\n',char(newName));
        delete(newName);
    end
end
    
fitswrite(Data,char(newName));
% first remove the inserted matlab comments
fptr= fits.openFile(char(newName),'readwrite');
fits.writeComment(fptr,'Aligned data cube allgoritms, TAOSII team');
fits.writeComment(fptr,'Authors: BHV/JSS/ESM');
dt=datetime('now');
sdt= sprintf('Date of Run: %s',dt);
fits.writeComment(fptr,sdt);

% New file Name
fits.writeKey(fptr,'ANAME',char(onlyName),'Add  [BrAL...] postfix');
fits.writeComment(fptr,'Br: Bias removed; AL: Aligned; 2: 2nd aligned; U: usuable area');
fits.writeComment(fptr,'S: Sky background without trend; M: Median removed (without star)');
fits.writeComment(fptr,'P: only stars patch');

% Usable Area affter allign
% min/max Coor is in Image  Coord that mean
%that axisX is the seconde component (the columns)  and
% the axisY is firts component  (the row) 
%UAREA=[minX:maxX,minY:masY] format
str_uArea=sprintf('[%d:%d,%d:%d]', minCoor1(1),maxCoor1(1),...
    minCoor1(2),maxCoor1(2));
fits.writeKey(fptr,'AAREA',str_uArea,'Usuable area 1');

str_uArea=sprintf('[%d:%d,%d:%d]', minCoor2(1),maxCoor2(1),...
    minCoor2(2),maxCoor2(2));
fits.writeKey(fptr,'AAREA2',str_uArea,'Usuable area 2');

% from original observation

fits.writeKey(fptr,'DATE-OBS',char(val1),'By original file');
fits.writeKey(fptr,'MJD',double(val2),'By original file');
fits.writeKey(fptr,'CCD_NAME',val3,'By original file');
fits.writeKey(fptr,'EXPTIME',single(val4),'By original file');


fits.closeFile(fptr);

if debug
    fitsdisp(char(newName),'mode','full');
end

end

